//rob@m0dts.co.uk 2015
//www.m0dts.co.uk

module read_ADC (

    input CLOCK_50,
	 input ADC_DOUT,
    output [7:0] LEDG,
	 output ADC_CS,
	 output ADC_DIN,
	 output ADC_SCLK,
	 output TEST,
	 output [7:0] DAC_OUT,
	 input button,
	 input sw0
    
);


    reg [32:0] counter;
	 reg [32:0] counter2 =0,counter3=11,trig=0,clk2_cnt,buf_cnt,sin_cnt,cos_cnt;
    reg [0:0] sclk, sclk2,csel, din,dout,clk2;
	 reg [7:0] control = 8'b00000000;	//channel0
	 reg [10:0] adcval;
	 reg signed [7:0] adcval2;
	 reg [7:0] dacout,ledtmp;
	 reg signed [23:0] fil_buf [100:0];
	 reg signed [7:0] coeff_ssb [100:0];
	 reg signed [7:0] coeff_cw [100:0];
	 reg signed [23:0] fil_sum,mult;
	 reg signed [7:0] sintable [4094:0];
	 reg [7:0] temp,temp2;
	 reg signed [7:0] coeff_tmp;
	 integer i;
	 
	initial
	begin
		$readmemh ("sin.hex", sintable);
		$readmemh ("coeff_ssb.hex", coeff_ssb);
		$readmemh ("coeff_cw.hex", coeff_cw);
	end
	 
	 
	 initial csel =1;
	 initial din =1;
	 initial clk2_cnt=0;
	 initial buf_cnt=0;
	 initial dacout=255;
	 initial sin_cnt=0;
	 initial cos_cnt=1024;
	 
	assign LEDG = ledtmp;
   // assign LEDG[0] = adcval[3];
   // assign LEDG[1] = adcval[4];
	// assign LEDG[2] = adcval[5];
	// assign LEDG[3] = adcval[6];
	// assign LEDG[4] = adcval[7];
	// assign LEDG[5] = adcval[8];
	// assign LEDG[6] = adcval[9];
	// assign LEDG[7] = adcval[10];
	 assign ADC_CS = csel;
	 assign ADC_DIN = din;
	 assign ADC_SCLK = sclk;
	 assign TEST = sclk2;
	 assign DAC_OUT = dacout;
    
 
 
 
 
	 always @ (posedge CLOCK_50) 
	 begin
		clk2_cnt <= clk2_cnt +1;
		if (clk2_cnt==8)
		begin
			clk2 <= ~clk2;
			clk2_cnt <= 0;
		end
    end
/*	 
	 always @ (negedge clk2) 
	 begin
		if (cos_cnt==4094)
			cos_cnt <=0;
		else
			cos_cnt <= cos_cnt+1;
		//dacout <= sinetable[counter2];
    end
 
 	 always @ (negedge clk2) 
	 begin
		if (sin_cnt2==4094)
			sin_cnt2 <=0;
		else
			sin_cnt2 <= sin_cnt2+1;
		//dacout <= sinetable[counter2];
    end
 
 */
 
 
    always @ (posedge CLOCK_50) 
	 begin
        counter <= counter + 1;
        sclk <= counter[4];	// 50/16 = 3.125MHz
		  sclk2 <= counter[10];	// 50/16777216 = 3hz?
    end
	 
	 

	

	 always @ (negedge sclk) 	//count 16bits for chip select low
	 begin
		if (sclk2==0)
		begin
			trig <= trig +1;
			if (trig < 15)
			begin
				csel <=0;
			end
			else
				csel <=1;
		end
		else
			trig <= 0;
	 end
	 
	 
	 
	 
	always @ (negedge sclk) 	//write bits
	begin
		if (csel==0)
		begin 	
			counter2 <= counter2 +1;
			if (counter2 < 8 )
				din = control[counter2];	
			if (counter3 ==0 )
				counter2 <= 0;
		end
	end
	 
	 
	 
	always @ (posedge sclk) 	//read bits
	begin
	if (csel==0)
		begin
			if (counter2 >3 )
			begin
				adcval[counter3] = ADC_DOUT;
				counter3 <= counter3 -1;
			end
			
			if (counter3 ==0 )
			begin
				counter3 <= 11;
			end
		end
	 end
 
	
	
	always @ (posedge csel) 	//shift adc values all at once to R2R DAC
	begin	
		// convert 11bit to 8bit, drop lsb
		adcval2 <= adcval[10:3];
		
		
/*		
		if (!button)
		begin
			temp= sintable[sin_cnt];
			temp2 = sintable[sin_cnt2];//temp-8'b10000000;
			//temp = temp>>4;
			end
		else
			temp =1;
			
*/
		
		//insert new val at buf0, subtract dc ref
		fil_buf[0] = adcval2-8'b10000000;
		//fil_buf[0] = fil_buf[0] *(sintable[sin_cnt]-8'b10000000);
		
		//shift buffer right 1
		for(i=100; i>0; i=i-1) begin
			fil_buf[i] = fil_buf[i-1];
		end
		
		//apply coeff
		for(i=0; i<101; i=i+1) begin
			if (i==0)
				fil_sum=0;
			if (sw0)
				coeff_tmp = coeff_ssb[i];
			else
				coeff_tmp = coeff_cw[i];
				
			fil_sum = fil_sum + (fil_buf[i] * coeff_tmp);
		end
		
		//scale fir   sqrt(coeff[x...x]*coeff[x...x])
		if (sw0)
			fil_sum =fil_sum>>9;
		else
			fil_sum =fil_sum>>11;
		
		
		//display absolute magnitude on leds
		if (fil_sum[7]==1'b1) 
			ledtmp <= -fil_sum[7:0];
		else
			ledtmp <= fil_sum[7:0];

		//output filtered sample
		if (button)
			dacout <= fil_sum[7:0]+8'b10000000;//(fil_sum >>6)+8'b10000000;
		else
			dacout <= fil_buf[buf_cnt][7:0]+8'b10000000;
	end
	

endmodule
